diff -Naur nrpe-2.5/src/nrpe.c nrpe-2.5.ipv4/src/nrpe.c
--- nrpe-2.5/src/nrpe.c	2006-03-25 15:23:32.000000000 +0100
+++ nrpe-2.5.ipv4/src/nrpe.c	2006-03-25 18:26:20.310220083 +0100
@@ -882,7 +882,8 @@
 	int result=0;
         struct hostent *myhost;
 	char **pptr=NULL;
-	char resolved_addr[INET6_ADDRSTRLEN]="";
+	char *save_connecting_host;
+	struct in_addr addr;
 	
 	/* make sure we have something */
 	if(connecting_host==NULL)
@@ -909,6 +910,7 @@
 		if((temp_buffer=strdup(allowed_hosts))==NULL)
 			return 0;
 
+		save_connecting_host = strdup(connecting_host);
 		for(temp_ptr=strtok(temp_buffer,",");temp_ptr!=NULL;temp_ptr=strtok(NULL,",")){
 
 			myhost=gethostbyname(temp_ptr);
@@ -916,9 +918,8 @@
 
 				/* check all addresses for the host... */
 				for(pptr=myhost->h_addr_list;*pptr!=NULL;pptr++){
-
-					inet_ntop(myhost->h_addrtype,*pptr,resolved_addr,sizeof(resolved_addr));
-					if(!strcmp(resolved_addr,connecting_host)){
+					memcpy(&addr, *pptr, sizeof(addr));
+					if(!strcmp(save_connecting_host, inet_ntoa(addr))){
 						result=1;
 						break;
 					        }
@@ -928,6 +929,8 @@
 			if(result==1)
 				break;
 		        }
+			strcpy(connecting_host, save_connecting_host);
+			free(save_connecting_host);
 	        }
 
 	free(temp_buffer);
